'MLLL (12/7/92)
'                  -----------------------------
'                  |    rduction d'un rseau  |
'                  -----------------------------
' rfrence :
'M. Pohst
'J. Symbolic Computation 4,123-7 (1987)
'also reprinted in
'Algorithmic Methods in Algebraic and Number Theory (AP 1987) pp 123-7
'
'Entre: index n,g
'        e -> tableau de var, donnant les litraux e(j) j=1  n  (codage des vecteurs de R^n)
'        f -> tableau de var, donnant les litraux f(i) i=1  g  (codage des vecteurs de R^g)
'             (e et f peuvent etre identiques)
'        a -> tableau de var
'             g vecteurs de R^n non nuls a(1), a(2),...,  a(g)
'                exemple a(3)=e(4)-2*e(5)
'        beta   index pour la sortie
'        b, mr tableaux pour la sortie
'
'Sortie: beta (valeur mise) vecteurs indpendants b(1), ..., b(beta) de R^n
'                exemple b(1)=2*e(1)-3*e(2)
'          tels que somme(i=1,g of Z a(i))=somme directe(j=1,beta of Z b(j))
'
'       g-beta vecteurs-relations mr(1),...,m(g-beta) de R^g
'                exemple mr(1)=2*f(1)+f(2) <=> 2*a(1)+a(2)=0
'
' Nota: Si on dsire obtenir les vecteurs b(1),...,b(beta) en fonction
'       des vecteurs a(1),...,a(g), on rendra le tableau "var h(g)"
'       global : par exemple h(2)=f(2)-2*f(1) indique que b(2)=b(2)-2*b(1).
'
'---------------------------------------------------
' Exemple de M. Pohst
'
'---------------------------------------------------
' Exemple
n=4
g=3
lit e(n),f(g)
var E(n),F(g),a(g),b(g),mr(g),beta
for i=1,n
E(i)=e(i)
next i
for i=1,g
F(i)=f(i)
next i
a(1)=e(1)+12345*e(4)
a(2)=e(2)+12435*e(4)
a(3)=e(3)+12354*e(4)
MLLL(n,g,E,F,a,b,mr,beta)
print "beta=";beta
for i=1,beta
print "b(";justl$(i);")=";b(i)
next i
if g-beta>0
for i=1,g-beta
print "mr(";justl$(i);")=";mr(i)
next i
endif
stop
'----------------------------------------------------------------------

MLLLerr:print "*erreur* dans les donnes de MLLL. ";@1
stop
MLLL:procedure(index n,g, access e(@1),f(@2),a(@2),b(@2),mr(@2),beta)
'verifs
ift g<2 MLLLerr "Dimension g<2.   g="&g
ift n<1 MLLLerr "Dimension n<1.   n="&n
local index i,j,k,alpha,sigma,tau,m,l
local var w1,w2,w11,w12,w21,w22,mu(g,g),B(g),bs(g),t,mus,Bs
local var h(g)
for i=1,n
ift not litp(e(i)) MLLLerr "e("&i&") non littral ="&e(i)
if i>1
for j=1,i-1
ift e(i)=e(j) MLLLerr "e("&i&")=e("&j&")="&e(i)
next j
endif
next i
for i=1,g
ift not litp(f(i)) MLLLerr "f("&i&") non littral ="&f(i)
if i>1
for j=1,i-1
ift f(i)=f(j) MLLLerr "f("&i&")=f("&j&")="&f(i)
next j
endif
next i
for i=1,g
w1=sum(j=1,n of coef(a(i),e(j))*e(j))
ift a(i)<>w1 MLLLerr "criture incorrecte de a("&i&")="&a(i)
ift a(i)=0 MLLLerr "vecteur nul a("&i&")="&a(i)
next i
'step 1
beta=0
tau=2
MLLL2:alpha=alpha+1
beta=beta+1
h(beta)=f(alpha)
b(beta)=a(alpha)
bs(beta)=b(beta)
if beta>1
for j=1,beta-1
mu(beta,j)=sum(k=1,n of coef(b(beta),e(k))*coef(bs(j),e(k)))/B(j)
bs(beta)=bs(beta)-mu(beta,j)*bs(j)
next j
endif
B(beta)=sum(k=1,n of coef(bs(beta),e(k))^2)
'print "b*(";justl$(beta);")=";bs(beta);"   B=";B(beta)
ift B(beta)<>0 and alpha<g goto MLLL2
m=tau
MLLL3:l=m-1
MLLL4:
if abs(mu(m,l))>1/2
t=cint(mu(m,l))
b(m)=b(m)-t*b(l)
h(m)=h(m)-t*h(l)
mu(m,l)=mu(m,l)-t
if l>1
for j=1,l-1
mu(m,j)=mu(m,j)-t*mu(l,j)
next j
endif
endif
ift b(m)=0 goto MLLL9
ift l<m-1 goto MLLL6
'step 5
ift B(m)<(3/4-mu(m,m-1)^2)*B(m-1) goto MLLL7
'step 6
MLLL6:l=l-1
ift l>0 goto MLLL4
m=m+1
ift m>beta return
goto MLLL3
MLLL7:mus=mu(m,m-1)
Bs=B(m)+mus^2*B(m-1)
ift Bs=0 goto MLLL8
mu(m,m-1)=mus*B(m-1)/Bs
B(m)=B(m)*B(m-1)/Bs
if m+1<=beta
w11=mu(m,m-1)
w12=1-mus*mu(m,m-1)
w21=1
w22=-mus
for i=m+1,beta
w1=mu(i,m-1)
w2=mu(i,m)
mu(i,m-1)=w11*w1+w12*w2
mu(i,m)=w21*w1+w22*w2
next i
endif
MLLL8:B(m-1)=Bs
exg h(m),h(m-1)
exg b(m),b(m-1)
if m>2
for j=1,m-2
exg mu(m-1,j),mu(m,j)
next j
m=m-1
endif
goto MLLL3
MLLL9:sigma=sigma+1
beta=beta-1
mr(sigma)=h(m)
if m<=beta
copy b(m+1),beta-m+1,1,b(m),1
copy h(m+1),beta-m+1,1,h(m),1
endif
ift alpha>=g return
if m<=beta
for i=m,beta
bs(i)=b(i)
if i>1
for j=1,i-1
mu(i,j)=sum(k=1,n of coef(b(i),e(k))*coef(bs(j),e(k)))/B(j)
bs(i)=bs(i)-mu(i,j)*bs(j)
next j
endif
B(i)=sum(k=1,n of coef(bs(i),e(k))^2)
next i
endif
tau=min(m+1,beta+1)
goto MLLL2
--------------------------fin de MLLL-----------------------------------
